# std::_Sp_counted_deleter< _Ptr, _Deleter, _Alloc, _Lp > Class Template Reference

Inheritance diagram for std::_Sp_counted_deleter< _Ptr, _Deleter, _Alloc, _Lp >:

List of all members.

## Detailed Description

### template<typename _Ptr, typename _Deleter, typename _Alloc, _Lock_policy _Lp>
class std::_Sp_counted_deleter< _Ptr, _Deleter, _Alloc, _Lp >

Definition at line 95 of file bits/boost_sp_shared_count.h.

## Public Member Functions

- void _M_add_ref_copy ()
- template<> void _M_add_ref_lock ()
- template<> void _M_add_ref_lock ()
- template<> void _M_add_ref_lock ()
- void _M_add_ref_lock ()
- virtual void _M_destroy ()
- virtual void _M_dispose ()
- virtual void * _M_get_deleter (const std::type_info &__ti)
- long _M_get_use_count () const
- void _M_release ()
- void _M_weak_add_ref ()
- void _M_weak_release ()
- _Sp_counted_deleter (_Ptr __p, _Deleter __d, const _Alloc &__a)
- _Sp_counted_deleter (_Ptr __p, _Deleter __d)

## Protected Types

- enum { _S_need_barriers }
- typedef _Sp_counted_ptr< _Ptr,
  _Lp > _Base_type

## Protected Attributes

- _My_Deleter _M_del
- _Ptr _M_ptr

## Constructor & Destructor Documentation

template<typename _Ptr, typename _Deleter, typename _Alloc, _Lock_policy _Lp>

std::_Sp_counted_deleter< _Ptr, _Deleter, _Alloc, _Lp >::_Sp_counted_deleter | ( | _Ptr | __p,
|  | _Deleter | __d |
| ) |  |  | `[inline]`

Precondition:
  __d(__p) must not throw.

Definition at line 120 of file bits/boost_sp_shared_count.h.

template<typename _Ptr, typename _Deleter, typename _Alloc, _Lock_policy _Lp>

std::_Sp_counted_deleter< _Ptr, _Deleter, _Alloc, _Lp >::_Sp_counted_deleter | ( | _Ptr | __p,
|  | _Deleter | __d,
|  | const _Alloc & | __a |
| ) |  |  | `[inline]`

Precondition:
  __d(__p) must not throw.

Definition at line 127 of file bits/boost_sp_shared_count.h.

The documentation for this class was generated from the following file:

- bits/boost_sp_shared_count.h